import unittest

import support
support.initthuban()

from Thuban.UI.classmapper import ClassMapper

class TestMapping(unittest.TestCase):

    def test_mapper(self):
        class MyClass:
            pass

        class MySecondClass:
            def hello(self):
                return "Hello World!"

        mapping = ClassMapper()
        instance = MyClass()

        # See if an empty mapping really returns False
        #
        self.assertEqual(mapping.get(instance), None)
        self.assertEqual(mapping.has(instance), False)

        # See if an installed mapping works
        #
        mapping.add(MyClass, MySecondClass)
        self.assertEqual(mapping.get(instance), MySecondClass)
        self.assertEqual(mapping.has(instance), True)

        # Ensure that it's really the class we put in and the method
        # is available as expected.
        #
        myinst = mapping.get(instance)()
        self.assertEqual(myinst.hello(), "Hello World!")


if __name__ == "__main__":
    support.run_tests()
